CREATE OR REPLACE PROCEDURE GRAVA_PEDIDO_XML_NF(P_NRACESSONFE IN VARCHAR2,
                                                P_CDFILIAL IN VARCHAR2,
                                                P_CDOPERADOR IN VARCHAR2)
IS
   V_PEDJAUTILIZADO FLOAT;
   V_SEQUENCIAL VARCHAR2(20);
   V_CDCLIENTE VARCHAR2(21);
   V_CDVENDEDOR VARCHAR2(4);
   V_CDMODPGTO VARCHAR2(5);
   V_VRNOTAFISC FLOAT;
   V_CDFORNECED VARCHAR2(21);
   V_NRINSJURFORN VARCHAR2(21);
   V_NRPEDIDO VARCHAR2(10);
   V_NRITEMPED VARCHAR2(10);
   V_CDPRODUTOFOR VARCHAR2(10);
   V_NRNOTAFISC VARCHAR2(20);
   V_IDIMPPEDIDO_EXT VARCHAR2(01);
   V_EXISTEIDUNPADRAO VARCHAR2(01);
   V_CDPRODUTOPEDIDO VARCHAR2(10);
   V_QTITEMPRODPED FLOAT;
   V_QTVOLUMES FLOAT;
   V_QTPROPVOLUME FLOAT;
BEGIN
   BEGIN
      SELECT COUNT(*)
        INTO V_PEDJAUTILIZADO
        FROM PEDIDO P 
       WHERE P.NRACESSONFE = P_NRACESSONFE
         AND EXISTS (SELECT NRGRADEPED
                       FROM GRADEPEDIDO G 
                      WHERE P.CDFILIAL = G.CDFILIAL
                        AND P.NRPEDIDO = G.NRPEDIDO);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_PEDJAUTILIZADO := 0;
   END;
   
   IF V_PEDJAUTILIZADO = 0 THEN
   
      SELECT NF.CDCLIENTE,
             NF.NRINSJURNF,
             NF.NRNOTAFISC
        INTO V_CDCLIENTE,
             V_NRINSJURFORN,
             V_NRNOTAFISC
        FROM INTG_SAID_NF NF
       WHERE NF.NRACESSONFS = P_NRACESSONFE;

      BEGIN
         SELECT CDFORNECED,
                NVL(IDIMPPEDIDO_EXT, 'N')
           INTO V_CDFORNECED,
                V_IDIMPPEDIDO_EXT
           FROM FORNECEDOR
          WHERE NRINSJURFORN = V_NRINSJURFORN;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CDFORNECED := NULL;
            V_IDIMPPEDIDO_EXT := 'N';
      END;

      IF V_IDIMPPEDIDO_EXT = 'N' THEN

         DELETE
           FROM PEDIDO
          WHERE NRACESSONFE = P_NRACESSONFE;

         SELECT P.CDVENDEDOR,
                P.CDMODPGTO
           INTO V_CDVENDEDOR,
                V_CDMODPGTO
           FROM PARAMPEDIDO P
          WHERE P.CDFILIAL = P_CDFILIAL;

         SELECT MAX(PR.NRPEDIDO),
                MAX(PR.NRITEMPED)
           INTO V_NRPEDIDO,
                V_NRITEMPED
           FROM INTG_SAID_PROD PR
          WHERE PR.NRACESSONFS = P_NRACESSONFE;

         NOVO_CODIGO_SC('PEDIDO'||P_CDFILIAL, V_SEQUENCIAL);
         V_SEQUENCIAL := SUBSTR(V_SEQUENCIAL, -10);

         INSERT INTO PEDIDO
            (NRPEDIDO, CDCLIENTE, CDFILIAL, CDVENDEDOR,
             DTPEDIDO, DTENTPED, IDPRIOPED, DTHRLANPED,
             CDOPELANPED, IDSITPEDIDO, CDMODPGTO, VRPLIQVOLPED,
             IDTIPOPEDIDO, CDTIPOOPER, IDENTRSAIDOP, CDFORNECEDPED,
             NRPEDIDO_PROT, NRSEQPEDIDO_PROT, DSPEDCLI, NRACESSONFE)
         VALUES(V_SEQUENCIAL, V_CDCLIENTE, P_CDFILIAL, V_CDVENDEDOR,
                TRUNC(SYSDATE), TRUNC(SYSDATE), '2', SYSDATE,
                P_CDOPERADOR, '2', V_CDMODPGTO, V_VRNOTAFISC,
                '1', '01', 'S', V_CDFORNECED,
                V_NRPEDIDO, V_NRITEMPED, 'NF: '||V_NRNOTAFISC, P_NRACESSONFE);

         FOR C_INTG_SAID_PROD IN (SELECT NRSEQITPROD, CDPRODUTO, QTITEMPROD, VRUNITITEM,
                                         NRPEDIDO, NRITEMPED
                                    FROM INTG_SAID_PROD PR
                                   WHERE PR.NRACESSONFS = P_NRACESSONFE)
         LOOP
            SELECT CDPRODUTO
              INTO V_CDPRODUTOFOR
              FROM PRODFORNXML PX
             WHERE PX.CDFORNECED = V_CDFORNECED
               AND PX.CDPRODUTOXML = C_INTG_SAID_PROD.CDPRODUTO;
            
            SELECT CASE NVL(PRE.IDUNPADRAO, 'N') WHEN 'S' THEN 'S' ELSE CASE NVL(PRC.IDUNPADRAO, 'N') WHEN 'S' THEN 'S' ELSE 'N' END END,
                   CASE WHEN (NVL(PRE.IDUNPADRAO, 'N') = NVL(PRC.IDUNPADRAO, 'N')) THEN V_CDPRODUTOFOR ELSE CASE NVL(PRE.IDUNPADRAO, 'N') WHEN 'S' THEN P.CDPRODESTO ELSE P.CDPRODUTO END END
              INTO V_EXISTEIDUNPADRAO,
                   V_CDPRODUTOPEDIDO
              FROM PRODUTO P JOIN PRODFILI PRC ON (P.CDPRODUTO = PRC.CDPRODUTO)  /* PRC: PRODFILI PARA OS PRODUTOS DE COMPRA */
                                              AND (PRC.CDFILIAL = P_CDFILIAL)
                             JOIN PRODFILI PRE ON (P.CDPRODESTO = PRE.CDPRODUTO) /* PRE: PRODFILI PARA OS PRODUTOS DE ESTOQUE */
                                              AND (PRE.CDFILIAL = P_CDFILIAL)
             WHERE P.CDPRODUTO = V_CDPRODUTOFOR;

            V_QTITEMPRODPED := C_INTG_SAID_PROD.QTITEMPROD;

            IF (V_EXISTEIDUNPADRAO = 'S') THEN
               /* 
                  FOI COLOCADO DEFAUL 1 POIS MESMO QUE EXISTA A EMBALAGEM PADRO 
                  CADASTRADO SEM O CADASTRO DA PROPORO O VALOR DA QUANTIDADE
                  NO SER AFETADA
               */
               BEGIN
                  SELECT NVL(QTVOLUMES, 1),
                         NVL(QTPROPVOLUME, 1)
                    INTO V_QTVOLUMES,
                         V_QTPROPVOLUME
                    FROM PRODUTO
                   WHERE CDPRODUTO = V_CDPRODUTOPEDIDO;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_QTVOLUMES := 1;
                     V_QTPROPVOLUME := 1;
               END;
               
               IF (V_QTPROPVOLUME > 0) THEN
                  V_QTITEMPRODPED := CEIL((C_INTG_SAID_PROD.QTITEMPROD / V_QTPROPVOLUME) * V_QTVOLUMES);
               END IF;
            END IF;
            
            INSERT INTO ITEMPEDIDO
               (NRPEDIDO, CDPRODUTO, QTITEMPED, VRPREUNITPED,
                NRITEMPED, IDSITITEMPED, CDFILIAL, CDOPERADOR,
                QTEXPITEMPED, NRPEDIDO_PROT, NRSEQITEMPED_PROT)
            VALUES
               (V_SEQUENCIAL, V_CDPRODUTOPEDIDO, V_QTITEMPRODPED, C_INTG_SAID_PROD.VRUNITITEM,
                C_INTG_SAID_PROD.NRSEQITPROD, '3', P_CDFILIAL, P_CDOPERADOR,
                0, C_INTG_SAID_PROD.NRPEDIDO, C_INTG_SAID_PROD.NRITEMPED);
         END LOOP;

         UPDATE INTG_SAID_NF
            SET IDPEDIDOGERADO = 'S'
          WHERE NRACESSONFS = P_NRACESSONFE;
         
         COMMIT;

      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_PEDIDO_XML_NF','6.05.xxx'); END;
/