var Fis04800_LivroEletronico_Controller = function(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
		    if(d1.getTime() > d2.getTime()){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoLivroEletronico','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(spedWidget) {
        var downloadRoute;
        var fileName;
        
        if(spedWidget.hasCheckedRows()){
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoLivroEletronico','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };
    
    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    
    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarLivroEletronico = function(livroEletronicoWidget) {
        if (livroEletronicoWidget.isValid()) {
            var row = livroEletronicoWidget.currentRow;
            
            // Preenche o VALORSTENTR, caso o mesmo esteja vazio.
            if(livroEletronicoWidget.currentRow.VALORSTENTR == "")
                 livroEletronicoWidget.currentRow.VALORSTENTR = "0";   
            // Converte valor do field VALORSTENTR para String.
            livroEletronicoWidget.currentRow.VALORSTENTR = livroEletronicoWidget.currentRow.VALORSTENTR.toString();
            var route = "fis#/exportarLivroEletronico";
            var message = Messages_fiscal.EXPORTANDO_LIVRO_ELETRONICO;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    /*
     * Função para alterar a propriedade readOnly dos campos de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function(livroEletronicoWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(livroEletronicoWidget);
        // Valida inscrição do substituto.
        this.inscricaoEstadualOnChange(livroEletronicoWidget);
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição 
     * municipal, conforme a inserção da inscrição estadual.
     */
    this.inscricaoEstadualOnChange = function(livroEletronicoWidget) {
        // Variável booleana que é setada como true caso alguma inscrição estadual
        // tenha sido selecionada.
        var inscricaoEstadualIsSelected = !!livroEletronicoWidget.currentRow.CDINSCESTA;
        var inscricaoMunicipalField = livroEletronicoWidget.getField('CDINSCMUNIC');

        // Altera as propriedades do field de inscrição do substituto e
        // reseta seu valor.
        inscricaoMunicipalField.readOnly = !inscricaoEstadualIsSelected;
        inscricaoMunicipalField.setValue(null);
        inscricaoMunicipalField.needReload = true;
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis04800_LivroEletronico_Controller', Fis04800_LivroEletronico_Controller);
});