var Fis85000_Sped_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZHPromise) {

    // Armazena o escopo atual.
    var self = this;

    self.addAgendamento = function(widget) {
        widget.newRow();
        widget.currentRow.CDARQUIVO = 'ICMS';
        this.arquivoOnChangeAgend(widget);
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function(args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.currentRow.CDARQUIVO = 'ICMS';
        this.arquivoOnChangeAgend(args.owner.widget);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function(widget) {
        if (widget.currentRow.CDTELA == 'FIS85000') {
            widget.currentRow.CDARQUIVO = 'ICMS';
        }
        else if (widget.currentRow.CDTELA == 'FIS95000') {
            widget.currentRow.CDARQUIVO = 'CONT';
            widget.currentRow.CDEMPRESA = widget.currentRow.CDEMPRESA.substr(1).substr(0, (widget.currentRow.CDEMPRESA.length - 2)).split('_');
            widget.currentRow.NMEMPRESA_MULT = widget.currentRow.CDEMPRESA;
        }
        General.edit(widget);
        this.arquivoOnChangeAgend(widget);
        this.periodicidadeOnChange(widget);
    };
    /*
     * Função para alterar a visibilidade e a validação required do campo de
     * inscrição, conforme arquivo selecionado.
     */
    this.arquivoOnChange = function(spedWidget) {
        var currentRow = spedWidget.currentRow;
        var empresaIsSelected = !!currentRow.CDEMPRESA;
        var inscricaoIsSelected = !!spedWidget.currentRow.CDINSCESTA;
        // Variável booleana que é setada como true quando o usuário seleciona
        // o arquivo de SPED Fiscal.
        var spedFiscalIsSelected = currentRow.CDARQUIVO == 'ICMS';
        var inscricaoField = spedWidget.getField('CDINSCESTA');

        var parametrosFiscalWidget = templateManager.container.getWidget("parametrosFiscal");
        var parametrosContribuicoesWidget = templateManager.container.getWidget("parametrosContribuicoes");

        // Reseta o nome do arquivo, caso esteja preenchido.
        currentRow.NMARQUIVO = "";

        // Altera as propriedades do field de inscrição conforme arquivo seleiconado.
        inscricaoField.validations = spedFiscalIsSelected ? { required: true } : {};
        inscricaoField.isVisible = spedFiscalIsSelected;

        // Altera a visibilidade das widgets de parametrização conforme o arquivo.
        parametrosFiscalWidget.showAsTab = spedFiscalIsSelected;
        parametrosContribuicoesWidget.showAsTab = !spedFiscalIsSelected;

        // Altera a habilitação da widget de parametrização conforme dados inseridos.
        parametrosFiscalWidget.enabled = spedFiscalIsSelected && empresaIsSelected && inscricaoIsSelected;
        parametrosContribuicoesWidget.enabled = !spedFiscalIsSelected && empresaIsSelected;

        // Altera o nome da widget principal conforme o arquivo.
        spedWidget.label = spedFiscalIsSelected ? "SPED Fiscal ICMS/IPI" : "SPED Contribuições";

        toggleBlocohFieldsVisibility(spedWidget, spedFiscalIsSelected);
    };

    this.arquivoOnChangeAgend = function(spedWidget) {
        var currentRow = spedWidget.currentRow;
        var empresaIsSelected = !!currentRow.CDEMPRESA;
        var inscricaoIsSelected = !!spedWidget.currentRow.CDINSCESTA;

        if (currentRow.CDARQUIVO == 'CONT') {
            spedWidget.getField('NMEMPRESA').isVisible = false;
            spedWidget.getField('NMEMPRESA_MULT').isVisible = true;
            spedWidget.getField('NMEMPRESA').validations = {};

        }
        else {
            spedWidget.getField('NMEMPRESA').isVisible = true;
            spedWidget.getField('NMEMPRESA_MULT').isVisible = false;
            spedWidget.getField('NMEMPRESA').validations = {
                "required": true
            };
        }
        spedWidget.getField('NMEMPRESA').reload();
        spedWidget.getField('NMEMPRESA_MULT').reload();

        // Variável booleana que é setada como true quando o usuário seleciona
        // o arquivo de SPED Fiscal.
        var spedFiscalIsSelected = currentRow.CDARQUIVO == 'ICMS';
        var inscricaoField = spedWidget.getField('CDINSCESTA');

        var parametrosFiscalWidget = templateManager.container.getWidget("parametrosFiscal");
        var parametrosContribuicoesWidget = templateManager.container.getWidget("parametrosContribuicoes");


        // Reseta o nome do arquivo, caso esteja preenchido.
        currentRow.NMARQUIVO = "";

        // Altera as propriedades do field de inscrição conforme arquivo seleiconado.
        //inscricaoField.validations = spedFiscalIsSelected ? {required: true} : {};
        inscricaoField.isVisible = spedFiscalIsSelected;

        // Altera a visibilidade das widgets de parametrização conforme o arquivo.
        parametrosFiscalWidget.showAsTab = spedFiscalIsSelected;
        parametrosContribuicoesWidget.showAsTab = !spedFiscalIsSelected;

        // Altera a habilitação da widget de parametrização conforme dados inseridos.
        parametrosFiscalWidget.enabled = spedFiscalIsSelected && empresaIsSelected && inscricaoIsSelected;
        parametrosContribuicoesWidget.enabled = !spedFiscalIsSelected && empresaIsSelected;

        // Altera o nome da widget principal conforme o arquivo.
        spedWidget.label = spedFiscalIsSelected ? "Agendamento SPED Fiscal ICMS/IPI" : "Agendamento SPED Contribuições";

        toggleBlocohFieldsVisibility(spedWidget, spedFiscalIsSelected);
    };

    self.periodicidadeOnChange = function(widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        }
        else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if ((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if ((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    self.saveAgendamento = function(widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if (((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)) {
                    widget.currentRow.CDINSCESTA = "T";
                }
                else if ((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == '')) {
                    widget.currentRow.CDEMPRESA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamento', 'Row', widget.currentRow).then(
                    function(success) {
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.currentRow.CDARQUIVO = 'ICMS';
                        this.arquivoOnChangeAgend(widget);
                        widget.reload();
                    }.bind(this),
                    function(error) {
                        ScreenService.showMessage(error.data.error);
                    }
                );
            }
            else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }

        }
        else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.deleteAgendamento = function(widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function(success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamento', 'Row', widget.currentRow).then(
                function(success) {
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error) {
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };

    /*
     * Função para setar os parâmetros como verificados ao sair da widget.
     */
    this.beforeExitParametrosGerais = function(parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    /*
     * Função auxiliar para a chamada da função de exportação no backend.
     * Criada para os casos onde há validação assíncrona antes da exportação.
     */
    var callExportacao = function(spedWidget) {
        spedWidget.currentRow.NRORG = getLocalVar('NRORG');
        var row = spedWidget.currentRow;
        var route = "fis#/exportarSped";
        var message = Messages_fiscal.EXPORTANDO_SPED;
        ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
    };

    self.downloadArquivoAgendado = function(spedWidget) {
        var downloadRoute;
        var fileName;
        var serviceUrl;
        General.callRestEngine('fis_acessorias#/getFileServerUrl', 'Row', { 'name': fileName }).then(
            function(sucess) {
                serviceUrl = sucess.dataset.sucess.fileName;
                //serviceUrl = sessionStorage.getItem('FileServerUrl');
                if (spedWidget.hasCheckedRows()) {
                    var rows = spedWidget.getCheckedRows();
                    rows.forEach(function(row) {
                        downloadRoute = window.serviceUrls.filter(function(x) { return x.package == 'fis'; })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                        fileName = row.NMPATHARQ;
                        if (fileName.match('teknisa/fis')) {
                            window.open(downloadRoute + row.NMPATHARQ);
                        }
                        else {
                            downloadRoute = window.serviceUrls.filter(function(x) { return x.package == 'fis'; })[0].baseUrl + "/downloadArquivoAgendamentoFileServer?requestType=Row&row[NMARQUIVO]=";
                            var rowDownload = {
                                'NMARQUIVO': row.NMARQUIVO,
                                'PATH': serviceUrl + fileName
                            };
                            window.open(downloadRoute + rowDownload.NMARQUIVO + '&row[PATH]=' + rowDownload.PATH);
                        }
                    });
                }
                else {
                    var row = spedWidget.currentRow;
                    downloadRoute = window.serviceUrls.filter(function(x) { return x.package == 'fis'; })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                    fileName = row.NMPATHARQ;
                    if (fileName.match('teknisa/fis')) {
                        window.open(downloadRoute + row.NMPATHARQ);
                    }
                    else {
                        downloadRoute = window.serviceUrls.filter(function(x) { return x.package == 'fis'; })[0].baseUrl + "/downloadArquivoAgendamentoFileServer?requestType=Row&row[NMARQUIVO]=";
                        var rowDownload = {
                            'NMARQUIVO': row.NMARQUIVO,
                            'PATH': serviceUrl + fileName
                        };
                        window.open(downloadRoute + rowDownload.NMARQUIVO + '&row[PATH]=' + rowDownload.PATH);
                    }
                }
            });
    };

    self.deleteArquivoAgendado = function(spedWidget) {
        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            General.callRestEngine('fis_acessorias#/deleteArquivo', 'DataSet', rows).then(
                function(sucesso) {
                    spedWidget.reload();
                },
                function(error) {
                    ScreenService.showMessage(error.dataset.error);
                }
            );
        }

    };

    /*
     * Função auxiliar chamada ao abrir o swipe de parâmetros para validar as
     * propriedades dos fields que são dependentes dos dados carregados/alterados.
     */
    var callFieldsOnChange = function(parametrosWidget) {
        // Verifica se é a widget de parametrização do SPED Contribuições.
        if (parametrosWidget.name == "parametrosContribuicoes") {
            // Chama as funções de FieldOnChange dessa widget.
            self.finalidadeArquivoContribuicoesOnChange(parametrosWidget, true);
            self.incidenciaTributariaOnChange(parametrosWidget, true);
        }
        else {
            self.geraBlocoKOnChange(parametrosWidget, true);
            self.controlaClassific(parametrosWidget, true);
            self.controlaInfComplementar(parametrosWidget, true);
        }
    };

    /*
     * Função para atualizar um field select conforme necessidade.
     * Caso algum filtro deste select seja alterado, por exemplo, a propriedade
     * "needReload" do field será setada pra true, indicando que o campo precisa
     * ser atualizado. Alterar a propriedade para false depois impede que o campo
     * sempre seja atualizado sem necessidade.
     */
    this.checkFieldNeedReload = function(field) {
        // Verifica se a propriedade não foi setada como false.
        if (field.needReload !== false) {
            // Caso não tenha, recarrega o field e seta a propriedade como false.
            field.reload();
            field.needReload = false;
        }
    };

    /*
     * Função auxiliar que verifica a parametrização do registro 1400 e a
     * necessidade de preencher dados relacionados em certos estados.
     */
    var checkRegistro1400 = function(spedWidget) {
        var currentRow = spedWidget.currentRow;
        // Verifica se a inscrição estadual é de um estado que precisa informar
        // os dados (MG/SP/ES/BA/PR).
        var estadoRequired = currentRow.SGESTADO == "MG" || currentRow.SGESTADO == "SP" || currentRow.SGESTADO == "ES" || currentRow.SGESTADO == "BA" || currentRow.SGESTADO == "PR";

        // Cria um backup e seta os dados na currentRow.
        spedWidget.backupRow = Util.clone(currentRow);
        currentRow.CDLIVROMAGADIC = null;
        currentRow.DTINIVAF = null;
        currentRow.DTFINVAF = null;

        // Se o registro 1400 foi preenchido e for necessário preencher os dados pro estado.
        if (currentRow.REG1400 && estadoRequired) {
            var registro1400TabbedWidget = templateManager.container.getWidget("registro1400Tabbed");
            var registro1400Widget = registro1400TabbedWidget.widgets[0];
            var dataInicial = registro1400Widget.getField("DTINIVAF");
            var dataFinal = registro1400Widget.getField("DTFINVAF");
            var insccentr = registro1400Widget.getField("CDINSCENTR");
            var agrupprod = registro1400Widget.getField("CDGRUPPROD");

            // Verifica se é o estado de Minas Gerais, que tem validação diferente.
            var isMinasGerais = currentRow.SGESTADO == "MG";
            // Verifica se é o estado da Bahia, que tem validação diferente.
            var isBahia = currentRow.SGESTADO == "BA";

            // Seta a currentRow da nova widget igual à da widget principal.
            registro1400Widget.currentRow = currentRow;

            // Verifica as validações dos campos conforme o estado selecionado.
            dataInicial.validations = isMinasGerais ? { required: true } : {};
            dataFinal.validations = isMinasGerais ? { required: true } : {};
            insccentr.validations = isBahia ? { required: true } : {};
            agrupprod.validations = isBahia ? { required: true } : {};

            dataInicial.isVisible = isMinasGerais;
            dataFinal.isVisible = isMinasGerais;
            insccentr.isVisible = isBahia;
            agrupprod.isVisible = isBahia;

            // Se for Minas Gerais, aplica os dados default (as datas).
            if (isMinasGerais) {
                registro1400Widget.applyDefaultValue();
            }

            // Exibe uma notificação pro usuário e abre o swipe com a widget
            // de parametrização do registro.
            ScreenService.showMessage(Messages_fiscal.INFORMAR_DADOS_REGISTRO1400)
                .then(function() {
                    registro1400Widget.activate();
                    ScreenService.openSwipe(registro1400TabbedWidget);
                });

            return false;
        }
        // Senão, retorna true.
        return true;
    };

    /*
     * Função chamada ao cancelar a inserção dos dados do registro 1400.
     */
    this.cancelRegistro1400 = function() {
        var spedWidget = templateManager.container.getWidget("sped");
        // Retorna a currentRow da widget principal para o estado anterior.
        Util.extend(spedWidget.currentRow, spedWidget.backupRow);

        ScreenService.closeSwipe();
        spedWidget.activate();
    };

    /*
     * Função chamada ao confirmar a inserção dos dados do registro 1400.
     */
    this.confirmRegistro1400 = function(registro1400Widget) {
        if (registro1400Widget.isValid()) {
            var currentRow = registro1400Widget.currentRow;
            var spedWidget = templateManager.container.getWidget("sped");

            // Verifica se há data inserida e se a data final é posterior à inicial.
            if (currentRow.DTINIVAF && moment(currentRow.DTFINVAF, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINIVAF, 'DD/MM/YYYY'))) {
                ScreenService.showMessage(Messages_fiscal.DTINI_POST_DTFIM_ERROR);
                return;
            }
            ScreenService.closeSwipe()
                .then(function() {
                    spedWidget.activate();
                    // Verifica se as informações do bloco H foram inseridas.
                    if (currentRow.IDGERABLOCOH == "N") {
                        ScreenService.showMessage(Messages_fiscal.INVENTARIO_SEM_INFORMACOES)
                            .then(function() {
                                // Chama a função de exportação após a confirmação.
                                callExportacao(spedWidget);
                            });
                    }
                    else {
                        // Chama a função de exportação sem exibir mensagem.
                        callExportacao(spedWidget);
                    }
                });
        }
    };

    /*
     * Função que altera a propriedade readOnly do campo de inscrição conforme
     * a inserção de empresa. Também reseta qualquer valor previamente preenchido.
     * Habilita ou desabilita a tab de Parâmetros Gerais conforme valores preenchidos.
     */
    this.empresaOnChange = function(spedWidget) {
        // Variável booleana que é setada como true caso o SPED selecionado seja o fiscal.
        var spedFiscalIsSelected = spedWidget.currentRow.CDARQUIVO == "ICMS";
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var empresaIsSelected = !!spedWidget.currentRow.CDEMPRESA;
        var inscricaoField = spedWidget.getField('CDINSCESTA');

        // Seleciona a widget de parâmetros conforme SPED escolhido.
        var parametrosWidget = spedFiscalIsSelected ? templateManager.container.getWidget('parametrosFiscal') : templateManager.container.getWidget('parametrosContribuicoes');
        // Altera a habilitação da widget de parâmetros gerais conforme o SPED
        // selecionado for Contribuições e se o campo de empresa tiver sido preenchido.
        parametrosWidget.enabled = empresaIsSelected && !spedFiscalIsSelected;

        // Altera as propriedades do field de inscrição e reseta seu valor.
        inscricaoField.readOnly = !empresaIsSelected;
        inscricaoField.setValue(null);
        inscricaoField.needReload = true;
    };

    /*
     * Função que habilita ou desabilita a tab de Parâmetros Gerais para o SPED
     * Fiscal conforme valores preenchidos.
     */
    this.inscricaoOnChange = function(spedWidget) {
        // Variável booleana que é setada como true caso alguma inscrição tenha sido selecionada.
        var inscricaoIsSelected = !!spedWidget.currentRow.CDINSCESTA;

        // Como o campo de inscrição só é habilitado para o SPED Fiscal,
        // seleciona a widget de parametrização correspondente.
        var parametrosWidget = templateManager.container.getWidget('parametrosFiscal');

        // Altera a habilitação da widget de parâmetros gerais
        // selecionado for Contribuições e se o campo de inscrição tiver sido preenchido.
        parametrosWidget.enabled = inscricaoIsSelected;

        // Chamada para a função que valida o estado da inscrição estadual
        this.toggleInscMunicipalVisibility(spedWidget);
    };

    /*
     * Função chamada ao apertar na action para exportar SPED.
     * Verifica validações e redireciona para a função de exportação.
     */
    this.exportarSped = function(spedWidget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (spedWidget.isValid()) {
            var currentRow = spedWidget.currentRow;
            // Verifica se há data de inventário fiscal e se a data final é
            // posterior à inicial.
            if (currentRow.DTINIPERFISC && moment(currentRow.DTFINPERFISC, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINIPERFISC, 'DD/MM/YYYY'))) {
                ScreenService.showMessage(Messages_fiscal.DTINI_POST_DTFIM_ERROR);
                return;
            }
            // Verifica se a parametrização para exportação foi verificada.
            if (!parametrizacaoWasLoaded(spedWidget)) {
                return;
            }

            // Verifica se o arquivo é do tipo Fiscal.
            if (currentRow.CDARQUIVO == "ICMS") {
                // Valida a necessidade de inserir as informações sobre valores
                // agregados.
                if (checkRegistro1400(spedWidget)) {
                    // Verifica se as informações do bloco H foram inseridas.
                    if (currentRow.IDGERABLOCOH == "N") {
                        ScreenService.showMessage(Messages_fiscal.INVENTARIO_SEM_INFORMACOES)
                            .then(function() {
                                // Chama a função de exportação após a confirmação.
                                callExportacao(spedWidget);
                            });
                    }
                    else {
                        // Chama a função de exportação sem exibir mensagem.
                        callExportacao(spedWidget);
                    }
                }
            }
            // Se não for, chama a exportação do SPED.
            else {
                callExportacao(spedWidget);
            }
        }
    };

    /*
     * Função chamada ao alterar o valor do campo "Finalidade do Arquivo" da
     * parametrização do SPED Contribuições.
     * Altera as validações do campo "Recibo Anterior".
     */
    this.finalidadeArquivoContribuicoesOnChange = function(args) {
        var widget = args.owner.owner.widget;
        var reciboField = widget.getField("STRECANT");
        var finalidade = widget.getField("STFINALIDADE");

        if (widget.currentRow.STFINALIDADE == "1") {
            reciboField.readOnly = false;
        }
        else {
            reciboField.readOnly = true;
        }
        finalidade.reload();
    };


    /* as informações sobre a versão (bo
     * Função chamada ao alterar o valor do campo "Gera Bloco K" da
     * parametrização do SPED Fiscal.
     * Altera as validações do campo "Origem Dados (Bloco K)".
     */
    this.geraBlocoKOnChange = function(parametrosWidget, openingSwipe) {
        // Verifica se foi marcada a opção "1" no campo.
        var geraBlocoK = parametrosWidget.currentRow.IDGERABLOCOK == "S";
        var origemDadosField = parametrosWidget.getField("IDORIGBLOCOK");

        // Altera a propriedade readOnly do campo.
        origemDadosField.readOnly = !geraBlocoK;
        origemDadosField.validations = geraBlocoK ? { required: true } : {};
        origemDadosField.reload();

        // Verifica se a função foi chamada pelo evento FieldOnChange e não
        // pela função de abrir o swipe.
        if (!openingSwipe) {
            // Reseta o valor do campo.
            origemDadosField.setValue('2');
        }
    };

    /*
     * Função chamada ao alterar o valor do campo "Incidência Tributária".
     * Altera as validações dos campos "Critério de Escrituração" e "Apropriação do Crédito".
     */
    this.incidenciaTributariaOnChange = function(args) {
        var widget = args.owner.owner.widget;
        var criterioField = widget.getField("STCRTESCRIT");
        var indicador = widget.getField("STINCTRIB");
        if (widget.currentRow.STINCTRIB == "2") {
            criterioField.readOnly = false;
        }
        else {
            criterioField.readOnly = true;
        }
        indicador.reload();
    };
    /*
     * Função para abrir o formulário com as parametrizações do SPED.
     * Abre uma widget diferente, conforme o arquivo escolhido.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function(spedWidget) {
        var currentRow = spedWidget.currentRow;
        var spedFiscalIsSelected = currentRow.CDARQUIVO == 'ICMS';

        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = spedFiscalIsSelected ? templateManager.container.getWidget('parametrosFiscal') : templateManager.container.getWidget('parametrosContribuicoes');

        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function() {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });

        // Abre a widget de parametrização do arquivo correspondente.
        spedWidget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };

    /*
     * Função auxiliar chamada ao tentar exportar um arquivo.
     * Retorna true caso a parametrização tenha sido verificada antes da exportação.
     * Abre a widget de parametrização caso contrário.
     */
    var parametrizacaoWasLoaded = function(spedWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdempresa = spedWidget.currentRow.CDEMPRESA;
        var cdinscesta = spedWidget.currentRow.CDINSCESTA;

        // Seleciona e valida a widget conforme o arquivo selecionado.
        if (spedWidget.currentRow.CDARQUIVO == 'ICMS') {
            parametrosWidget = templateManager.container.getWidget('parametrosFiscal');
            // Valida se a propriedade está setada para a empresa e inscrição estadual selecionados.
            parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdempresa] && parametrosWidget.empresasLoaded[cdempresa][cdinscesta];
        }
        else {
            parametrosWidget = templateManager.container.getWidget('parametrosContribuicoes');
            // Valida se a propriedade está setada para a empresa selecionada.
            parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdempresa];
        }

        // Verifica se a widget de parametrização foi aberta antes de exportar o arquivo.
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que seja obrigatório que a parametrização seja informada.
            parametrosWidget.parametersRequired = true;

            // Exibe a mensagem que indica que os parâmetros devem ser verificados.
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR)
                .then(function() {
                    // Abre a swipe da widget de parâmetros.
                    openTabParametrosGerais(spedWidget);
                });
            // Retorna false, indicando que a parametrização não foi previamente conferida.
            return false;
        }
        // Retorna true caso contrário, indicando que a parametrização foi previamente conferida.
        return true;
    };

    /*
     * Função para salvar a parametrização informada pelo usuário.
     */
    this.salvarParametrizacao = function(parametrosWidget) {
        // Verifica se todos os dados requeridos foram preenchidos.
        if (parametrosWidget.isValid()) {
            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosFiscal") {
                var currentRow = parametrosWidget.currentRow;

                // se o campo vier vazio, vai deletar ele e vai usar o default
                if (parametrosWidget.currentRow.IDGERACAMPO11ST == "") {
                    delete parametrosWidget.currentRow.IDGERACAMPO11ST;
                }
                if (parametrosWidget.currentRow.IDCLASSIFICESTAB == "") {
                    delete parametrosWidget.currentRow.IDCLASSIFICESTAB;
                }
                // Cria um array com os valores das obrigatoriedades resetados.
                var obrigatoriedadesArray = ["N", "N", "N", "N", "N", "N", "N", "N", "N"];

                // Para cada obrigatoriedade selecionada, muda o valor no array para "S".
                if (Array.isArray(currentRow.CDOBRIGARRAY)) {
                    currentRow.CDOBRIGARRAY.forEach(function(index) {
                        obrigatoriedadesArray[index] = 'S';
                    });
                }

                // Transforma o array em uma String e atribui ao campo.
                currentRow.CDOBRIGAREGBL1 = obrigatoriedadesArray.join("");
            }
            // Chama a função para salvar os dados.
            parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.STFINALIDADE;
            parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.STINCTRIB;
            parametrosWidget.currentRow.CDCAMPO10 = parametrosWidget.currentRow.STCRTESCRIT;
            
            parametrosWidget.saveRow()
                .then(function() {
                    var spedWidget = templateManager.container.getWidget("sped");

                    // Seta os parametros como verificados pelo usuário.
                    setParametersVerified(parametrosWidget);

                    // Altera a widget ativa para a principal.
                    spedWidget.activate();
                    spedWidget.currentWidget = spedWidget;

                    // Verifica se os parâmetros foram exibidos devido a uma
                    // tentativa de exportar o SPED. Em caso positivo, tenta
                    // exportar o SPED novamente.
                    if (parametrosWidget.parametersRequired) {
                        self.exportarSped(spedWidget);
                        // Retira a necessidade de exportar automaticamente ao
                        // abrir a parametrização novamente.
                        parametrosWidget.parametersRequired = false;
                    }
                });
        }
    };

    /*
     * Função para salvar o valor de um field com outro nome na currentRow.
     * Chamada pela parametrização do SPED Contribuições, devido ao fato deste
     * utilizar uma tabela genérica e campos com nomes genéricos, sendo necessário
     * salvar o valor com o nome original do campo.
     * Utilizado por fields select-native também devido ao fato do outData não
     * funcionar da maneira devida neste caso.
     */
    this.setCurrentRowValue = function(field) {
        // Seta a propriedade na currentRow com o mesmo valor do field.
        field.widget.currentRow[field.originalColumn] = field.value();
    };

    /*
     * Função para setar a currentRow da widget de parâmetros após o carregamento dos dados.
     * Altera, também, a propriedade que indica se já havia uma parametrização cadastrada.
     */
    this.setLoadedParameters = function(parametrosWidget) {
        var spedWidget = templateManager.container.getWidget("sped");

        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();

            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosFiscal") {
                var currentRow = parametrosWidget.currentRow;
                // O campo "CDOBRIGAREGBL1" possui a parametrização da obrigatoriedades dos registros (Bloco 1).
                // Os valores são armazenados em uma String na ordem de aparição dos campos,
                // sendo 'N' para "falso" e 'S' para "verdadeiro".
                var codigosArray = currentRow.CDOBRIGAREGBL1.split("");

                // Adiciona no array todos os valores marcados.
                currentRow.CDOBRIGARRAY = [];
                if (codigosArray[0] == 'S') {
                    // Registro 1100.
                    currentRow.CDOBRIGARRAY.push(0);
                }
                if (codigosArray[1] == 'S') {
                    // Registro 1200.
                    currentRow.CDOBRIGARRAY.push(1);
                }
                if (codigosArray[2] == 'S') {
                    // Registro 1300.
                    currentRow.CDOBRIGARRAY.push(2);
                }
                if (codigosArray[3] == 'S') {
                    // Registro 1390.
                    currentRow.CDOBRIGARRAY.push(3);
                }
                if (codigosArray[4] == 'S') {
                    // Registro 1400.
                    currentRow.CDOBRIGARRAY.push(4);
                }
                if (codigosArray[5] == 'S') {
                    // Registro 1500.
                    currentRow.CDOBRIGARRAY.push(5);
                }
                if (codigosArray[6] == 'S') {
                    // Registro 1600.
                    currentRow.CDOBRIGARRAY.push(6);
                }
                if (codigosArray[7] == 'S') {
                    // Registro 1700.
                    currentRow.CDOBRIGARRAY.push(7);
                }
                if (codigosArray[8] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(8);
                }
            }
        }
        else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = spedWidget.currentRow.CDEMPRESA;
            parametrosWidget.currentRow.CDINSCESTA = spedWidget.currentRow.CDINSCESTA;
        }

        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = spedWidget.currentRow.NMEMPRESA;

    };

    /*
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário.
     */
    var setParametersVerified = function(parametrosWidget) {
        var spedFiscalIsSelected = parametrosWidget.name == "parametrosFiscal";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (spedFiscalIsSelected) {
            var spedWidget = templateManager.container.getWidget("sped");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa e inscrição estadual selecionados.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA][currentRow.CDINSCESTA] = true;
            spedWidget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        }
        else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };

    /*
     * Função chamada ao alterar o campo "Gera informações do Inventário Fiscal".
     * Reseta os valores dos campos do fieldGroup relacionado e altera a propriedade
     * readOnly, conforme opção selecionada.
     */
    this.toggleBlocohFieldsReadonly = function(spedWidget) {
        var dataInicialField = spedWidget.getField("DTINIPERFISC");
        var dataFinalField = spedWidget.getField("DTFINPERFISC");
        var motivoField = spedWidget.getField("CDMOTINVENTARIO");
        var blocohEnabled = spedWidget.currentRow.IDGERABLOCOH == 'S';

        // Altera a propriedade readOnly dos campos, setando como true caso o valor seja 'N'.
        dataInicialField.readOnly = !blocohEnabled;
        dataFinalField.readOnly = !blocohEnabled;
        motivoField.readOnly = !blocohEnabled;

        // Altera a validação required dos campos, sendo requerido caso o valor seja 'S'.
        dataInicialField.validations = blocohEnabled ? { required: true } : {};
        dataFinalField.validations = blocohEnabled ? { required: true } : {};
        motivoField.validations = blocohEnabled ? { required: true } : {};

        // Seta os valores default caso o valor seja 'S'.
        if (blocohEnabled) {
            dataInicialField.applyDefaultValue();
            dataFinalField.applyDefaultValue();
        }
        // Seta os valores como nulos caso o valor seja 'N'.
        else {
            dataInicialField.setValue(null);
            dataFinalField.setValue(null);
        }

        // Reseta o valor do campo de Motivo, que não tem valor default.
        motivoField.setValue(null);
        spedWidget.reload();
    };

    /*
     * Função auxiliar chamada ao alterar o tipo de arquivo a ser exportado.
     * Muda a visibilidade e as validações dos fields relacionados ao inventário fiscal.
     */
    var toggleBlocohFieldsVisibility = function(spedWidget, isVisible) {
        var gerablocoField = spedWidget.getField("IDGERABLOCOH");
        var dataInicialField = spedWidget.getField("DTINIPERFISC");
        var dataFinalField = spedWidget.getField("DTFINPERFISC");
        var motivoField = spedWidget.getField("CDMOTINVENTARIO");

        // Busca o fieldGroup com os fields do Bloco H e seta a propriedade isVisible..
        spedWidget.fieldGroups.filter(function(fieldGroup) {
            return fieldGroup.name == "blocoh";
        })[0].isVisible = isVisible;

        // Altera a visibilidade dos campos conforme o arquivo selecionado.
        gerablocoField.isVisible = isVisible;
        dataInicialField.isVisible = isVisible;
        dataFinalField.isVisible = isVisible;
        motivoField.isVisible = isVisible;

        // Se for visível, verifica os valores e as propriedades dos fields.
        if (isVisible) {
            self.toggleBlocohFieldsReadonly(spedWidget);
        }
        // Senão, retira as validações dos fields.
        else {
            gerablocoField.validations = {};
            dataInicialField.validations = {};
            // dataFinalField.validations = {};
            motivoField.validations = {};
        }
    };

    /*
     * Função que altera a visibilidade do field CDINSCMUNI,
     * de acordo com o estado da Inscrição Estadual.
     */
    this.toggleInscMunicipalVisibility = function(widget) {
        var estado = widget.currentRow.SGESTADO;
        var arquivo = widget.currentRow.CDARQUIVO;
        var inscmuni = widget.getField('CDINSCMUNI');

        //Se o SPED Fiscal estiver selecionado e o estado selecionado for DF, habilita o field CDINSCMUNI
        if (estado == "DF" && arquivo == "ICMS") {
            inscmuni.validations = { "required": { "message": "Campo obrigatório" } };
            inscmuni.readOnly = false;
        }
        else {
            inscmuni.validations = {};
            inscmuni.readOnly = true;
            inscmuni.setValue("");
        }
    };

    this.controlaInfComplementar = function(parametrosWidget) {
        var nrdias = parametrosWidget.getField('NRDIAMEDIAEST');
        var geravalor = parametrosWidget.getField('IDGERACAMPO11ST');
        var indicador = parametrosWidget.getField('IDINFCOMPLST');

        nrdias.readOnly = true;
        geravalor.readOnly = true;
        indicador.reload();

        if (parametrosWidget.currentRow.IDINFCOMPLST == "S") {
            nrdias.readOnly = false;
            geravalor.readOnly = false;
            indicador.reload();
        }
        else {
            nrdias.readOnly = true;
            geravalor.readOnly = true;
            geravalor.clearValue();
            nrdias.clearValue();
            indicador.reload();
        }
        indicador.reload();

    };

    this.controlaClassific = function(parametrosWidget) {
        var classific = parametrosWidget.getField('IDCLASSIFICESTAB');
        var indicador = parametrosWidget.getField('IDINDATIVIDADE');

        classific.readOnly = true;
        indicador.reload();

        if (parametrosWidget.currentRow.IDINDATIVIDADE == "0") {
            classific.readOnly = false;
            indicador.reload();
        }
        else {
            classific.readOnly = true;
            classific.clearValue();
            indicador.reload();
        }
        indicador.reload();

    };
    
    this.motivInventOnChange = function(parametrosWidget) {
        // Verifica se foi marcada a opção "1" no campo.
        var motivInvent = parametrosWidget.currentRow.CDMOTINVENTARIO == "1";
        var H020Field = parametrosWidget.getField("H020");

        H020Field.setValue(motivInvent ? 'S' : 'N');
        parametrosWidget.currentRow.H020 = motivInvent ? 'S' : 'N';
        H020Field.reload();
    };

    this.verificaCampoVersao = function(widget) {
        var valorVersao = widget.getField("CDVERSAO").value();
        var codObrigacao = widget.getField("CDOBRIGARRAY").dataSource.data;
        
        if(valorVersao == "016" || valorVersao == "16"){
            codObrigacao[7].NMOBRIGA = '1601 - Operações com Instrumentos de Pagamentos Eletrônicos';
        } else {
            codObrigacao[7].NMOBRIGA = '1600 - Realizou vendas com Cartão de Crédito ou de débito';
        }
        
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Fis85000_Sped_Controller', Fis85000_Sped_Controller);
});
